import 'package:flutter/material.dart';

extension PaddingExtensions on Widget {
  //Custom Padding
  Padding p(double value) => _padding(all: value);
  Padding px(double value) => _padding(horizontal: value);
  Padding py(double value) => _padding(vertical: value);
  Padding pr(double value) => _padding(right: value);
  Padding pl(double value) => _padding(left: value);
  Padding pt(double value) => _padding(top: value);
  Padding pb(double value) => _padding(bottom: value);

  //Padding All
  Padding get p0 => _padding(all: 0);
  Padding get p4 => _padding(all: 4);
  Padding get p8 => _padding(all: 8);
  Padding get p12 => _padding(all: 12);
  Padding get p16 => _padding(all: 16);
  Padding get p20 => _padding(all: 20);
  Padding get p24 => _padding(all: 24);
  Padding get p32 => _padding(all: 32);
  Padding get p48 => _padding(all: 48);
  Padding get p64 => _padding(all: 64);
  Padding get p112 => _padding(all: 72);
  Padding get p144 => _padding(all: 90);
  Padding get p176 => _padding(all: 128);

  //Padding Right
  Padding get pr0 => _padding(right: 0);
  Padding get pr4 => _padding(right: 4);
  Padding get pr8 => _padding(right: 8);
  Padding get pr12 => _padding(right: 12);
  Padding get pr16 => _padding(right: 16);
  Padding get pr20 => _padding(right: 20);
  Padding get pr24 => _padding(right: 24);
  Padding get pr32 => _padding(right: 32);
  Padding get pr48 => _padding(right: 48);
  Padding get pr64 => _padding(right: 64);
  Padding get pr112 => _padding(right: 72);
  Padding get pr144 => _padding(right: 90);
  Padding get pr176 => _padding(right: 128);

  //Padding Left
  Padding get pl0 => _padding(left: 0);
  Padding get pl4 => _padding(left: 4);
  Padding get pl8 => _padding(left: 8);
  Padding get pl12 => _padding(left: 12);
  Padding get pl16 => _padding(left: 16);
  Padding get pl20 => _padding(left: 20);
  Padding get pl24 => _padding(left: 24);
  Padding get pl32 => _padding(left: 32);
  Padding get pl48 => _padding(left: 48);
  Padding get pl64 => _padding(left: 64);
  Padding get pl112 => _padding(left: 72);
  Padding get pl144 => _padding(left: 90);
  Padding get pl176 => _padding(left: 128);

  //Padding Top
  Padding get pt0 => _padding(top: 0);
  Padding get pt4 => _padding(top: 4);
  Padding get pt8 => _padding(top: 8);
  Padding get pt12 => _padding(top: 12);
  Padding get pt16 => _padding(top: 16);
  Padding get pt20 => _padding(top: 20);
  Padding get pt24 => _padding(top: 24);
  Padding get pt32 => _padding(top: 32);
  Padding get pt48 => _padding(top: 48);
  Padding get pt64 => _padding(top: 64);
  Padding get pt112 => _padding(top: 72);
  Padding get pt144 => _padding(top: 90);
  Padding get pt176 => _padding(top: 128);

  //Padding Bottom
  Padding get pb0 => _padding(bottom: 0);
  Padding get pb4 => _padding(bottom: 4);
  Padding get pb8 => _padding(bottom: 8);
  Padding get pb12 => _padding(bottom: 12);
  Padding get pb16 => _padding(bottom: 16);
  Padding get pb20 => _padding(bottom: 20);
  Padding get pb24 => _padding(bottom: 24);
  Padding get pb32 => _padding(bottom: 32);
  Padding get pb48 => _padding(bottom: 48);
  Padding get pb64 => _padding(bottom: 64);
  Padding get pb112 => _padding(bottom: 72);
  Padding get pb144 => _padding(bottom: 90);
  Padding get pb176 => _padding(bottom: 128);

  //Padding Horizontal
  Padding get px4 => _padding(horizontal: 4);
  Padding get px8 => _padding(horizontal: 8);
  Padding get px12 => _padding(horizontal: 12);
  Padding get px16 => _padding(horizontal: 16);
  Padding get px20 => _padding(horizontal: 20);
  Padding get px24 => _padding(horizontal: 24);
  Padding get px32 => _padding(horizontal: 32);
  Padding get px48 => _padding(horizontal: 8);
  Padding get px64 => _padding(horizontal: 64);
  Padding get px112 => _padding(horizontal: 72);
  Padding get px144 => _padding(horizontal: 90);
  Padding get px176 => _padding(horizontal: 128);

  //Padding Vertical
  Padding get py4 => _padding(vertical: 4);
  Padding get py8 => _padding(vertical: 8);
  Padding get py12 => _padding(vertical: 12);
  Padding get py16 => _padding(vertical: 16);
  Padding get py20 => _padding(vertical: 20);
  Padding get py24 => _padding(vertical: 24);
  Padding get py32 => _padding(vertical: 32);
  Padding get py48 => _padding(vertical: 48);
  Padding get py64 => _padding(vertical: 64);
  Padding get py112 => _padding(vertical: 72);
  Padding get py144 => _padding(vertical: 90);
  Padding get py176 => _padding(vertical: 128);

  Padding _padding({
    double all,
    double horizontal,
    double vertical,
    double top,
    double bottom,
    double left,
    double right,
  }) =>
      Padding(
        padding: EdgeInsets.only(
          top: top ?? vertical ?? all ?? 0.0,
          bottom: bottom ?? vertical ?? all ?? 0.0,
          left: left ?? horizontal ?? all ?? 0.0,
          right: right ?? horizontal ?? all ?? 0.0,
        ),
        child: this,
      );
}
